## open-coarrays 1.6.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

# Set the type/configuration of build to perform
set ( CMAKE_CONFIGURATION_TYPES "Debug" "Release" "MinSizeRel" "RelWithDebInfo" "CodeCoverage" )
set ( CMAKE_BUILD_TYPE "Release"
  CACHE STRING "Select which configuration to build." )
set_property ( CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS ${CMAKE_CONFIGURATION_TYPES} )

#Name project and specify source languages
project(opencoarrays VERSION 1.6.0 LANGUAGES C Fortran)

#Print an error message on an attempt to build inside the source directory tree:
if ("${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")
  message(FATAL_ERROR "ERROR! "
    "CMAKE_CURRENT_SOURCE_DIR=${CMAKE_CURRENT_SOURCE_DIR}"
    " == CMAKE_CURRENT_BINARY_DIR=${CMAKE_CURRENT_BINARY_DIR}"
    "\nThis archive does not support in-source builds:\n"
    "You must now delete the CMakeCache.txt file and the CMakeFiles/ directory under"
    "the 'src' source directory or you will not be able to configure correctly!"
    "\nYou must now run something like:\n"
    "  $ rm -r CMakeCache.txt CMakeFiles/"
    "\n"
    "Please create a directory outside the opencoarrays source tree and build under that outside directory "
    "in a manner such as\n"
    "  $ mkdir build-opencarrays\n"
    "  $ cd build-opencoarrays\n"
    "  $ CC=mpicc FC=mpif90 cmake <path-to-opencoarrays-source-directory> -DCMAKE_INSTALL_PREFIX=<path-to-install-directory>\n"
    "\nsubstituting the appropriate syntax for your shell (the above line assumes the bash shell)."
    )
endif()

#Report untested Fortran compiler unless explicitly directed to build all examples.
if ("${CMAKE_Fortran_COMPILER_ID}" MATCHES "GNU" )
  set(gfortran_compiler true)
  # add_definitions(-DPREFIX_NAME=_gfortran_caf_)
  set ( CMAKE_C_FLAGS_CODECOVERAGE "-fprofile-arcs -ftest-coverage -O0"
    CACHE STRING "Code coverage C compiler flags")
  set ( CMAKE_Fortran_FLAGS_CODECOVERAGE "-fprofile-arcs -ftest-coverage -O0"
    CACHE STRING "Code coverage C compiler flags")
else()
  message(WARNING
    "\n"
    "Attempting to build with untested Fortran compiler: ${CMAKE_Fortran_COMPILER_ID}. "
    "Please report any failures to opencoarrays@googlegroups.com\n\n"
  )
endif()

if (NOT (CMAKE_VERSION VERSION_LESS 3.3.1))
  # Detect Fortran compiler version directly
  if(gfortran_compiler AND (CMAKE_Fortran_COMPILER_VERSION VERSION_GREATER 5.0.0))
    set(opencoarrays_aware_compiler true)
    add_definitions(-DPREFIX_NAME=_gfortran_caf_)
  else()
    set(opencoarrays_aware_compiler false)
    add_definitions(-DPREFIX_NAME=_caf_extensions_)
  endif()
  if(gfortran_compiler AND (CMAKE_Fortran_COMPILER_VERSION VERSION_LESS 5.4))
    # GCC patch to fix issue accepted for 5.4 release
    # See https://github.com/sourceryinstitute/opencoarrays/issues/28 and
    # https://groups.google.com/forum/#!msg/opencoarrays/RZOwwYTqG80/46S9eL696dgJ
    message( STATUS "Disabling optimization flags due to GCC < 5.4 bug")
    set(CMAKE_Fortran_FLAGS_RELEASE -O0
      CACHE STRING "Flags used by the compiler during release builds." FORCE)
    set(CMAKE_Fortran_FLAGS_RELWITHDEBINFO "-g -DNDEBUG -O0"
      CACHE STRING "Flags used by the compiler during release builds with debug info" FORCE)
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -O0")
  endif()
else()
  # Use the C compiler version as a proxy for the Fortran compiler version (won't work with NAG)
  if(gfortran_compiler AND (CMAKE_C_COMPILER_VERSION VERSION_GREATER 5.0.0))
    set(opencoarrays_aware_compiler true)
    add_definitions(-DPREFIX_NAME=_gfortran_caf_)
  else()
    set(opencoarrays_aware_compiler false)
    add_definitions(-DPREFIX_NAME=_caf_extensions_)
  endif()
  if(gfortran_compiler AND (CMAKE_C_COMPILER_VERSION VERSION_LESS 5.4))
    # GCC patch to fix issue accepted for the 5.4 release
    # See https://github.com/sourceryinstitute/opencoarrays/issues/28 and
    # https://groups.google.com/forum/#!msg/opencoarrays/RZOwwYTqG80/46S9eL696dgJ
    message( STATUS "Disabling optimization flags due to GCC < 5.4 bug")
    set(CMAKE_Fortran_FLAGS_RELEASE -O0
      CACHE STRING "Flags used by the compiler during release builds." FORCE)
    set(CMAKE_Fortran_FLAGS_RELWITHDEBINFO "-g -DNDEBUG -O0"
      CACHE STRING "Flags used by the compiler during release builds with debug info" FORCE)
    set(CMAKE_Fortran_FLAGS "${CMAKE_Fortran_FLAGS} -O0")
  endif()
endif()

if(gfortran_compiler)
  set(CMAKE_REQUIRED_FLAGS "-fcoarray=single -ffree-form")
endif()
include(CheckFortranSourceCompiles)
CHECK_Fortran_SOURCE_COMPILES("
  program main
    implicit none
    integer :: i
    i = this_image()
  end program
" Check_Simple_Coarray_Fortran_Source_Compiles)
if(gfortran_compiler)
  unset(CMAKE_REQUIRED_FLAGS)
endif()

include_directories(${CMAKE_CURRENT_SOURCE_DIR}/src)

add_subdirectory(src)

#-----------------------------------------------------
# Publicize installed location to other CMake projects
#-----------------------------------------------------
install(EXPORT OpenCoarraysTargets
  NAMESPACE
    OpenCoarrays::
  DESTINATION
    lib/cmake/opencoarrays
)
include(CMakePackageConfigHelpers) # standard CMake module
write_basic_package_version_file(
  "${CMAKE_CURRENT_BINARY_DIR}/OpenCoarraysConfigVersion.cmake"
  VERSION "${opencoarrays_VERSION}"
  COMPATIBILITY AnyNewerVersion
)
configure_file("${CMAKE_SOURCE_DIR}/cmake/pkg/OpenCoarraysConfig.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/CMakeFiles/OpenCoarraysConfig.cmake" @ONLY)

install(
  FILES
    "${CMAKE_CURRENT_BINARY_DIR}/CMakeFiles/OpenCoarraysConfig.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/OpenCoarraysConfigVersion.cmake"
  DESTINATION
    lib/cmake/opencoarrays
)

add_library(OpenCoarrays INTERFACE)
target_compile_options(OpenCoarrays INTERFACE -fcoarray=lib)
target_link_libraries(OpenCoarrays INTERFACE caf_mpi)

install(DIRECTORY  ${CMAKE_BINARY_DIR}/mod DESTINATION .)

#------------------------------------------
# Add portable unistall command to makefile
#------------------------------------------
# Adapted from the CMake Wiki FAQ
configure_file ( "${CMAKE_SOURCE_DIR}/cmake/uninstall.cmake.in" "${CMAKE_BINARY_DIR}/uninstall.cmake"
    @ONLY)

add_custom_target ( uninstall
  COMMAND ${CMAKE_COMMAND} -P "${CMAKE_BINARY_DIR}/uninstall.cmake" )


enable_testing()

function(add_mpi_test name num_mpi_proc path)
   set(test_parameters ${MPIEXEC_NUMPROC_FLAG} ${num_mpi_proc} )
   add_test(NAME ${name} COMMAND ${MPIEXEC} ${test_parameters} "${path}")
   set_property(TEST ${name} PROPERTY PASS_REGULAR_EXPRESSION "Test passed.")
endfunction(add_mpi_test)

set(tests_root ${CMAKE_CURRENT_BINARY_DIR}/src/tests)

if(opencoarrays_aware_compiler)
  # Unit tests targeting each libcaf_mpi function, argument, and branch of code
  add_mpi_test(initialize_mpi 2 ${tests_root}/unit/init_register/initialize_mpi)
  add_mpi_test(register 2 ${tests_root}/unit/init_register/register)
  add_mpi_test(register_rename_me 2 ${tests_root}/unit/init_register/register_rename_me)
  add_mpi_test(register_rename_me_too 2 ${tests_root}/unit/init_register/register_rename_me_too)
  add_mpi_test(allocate_as_barrier 2 ${tests_root}/unit/init_register/allocate_as_barrier)
  if (NOT ( APPLE AND ( DEFINED ENV{TRAVIS} ) ) )
    add_mpi_test(allocate_as_barrier_proc 2 ${tests_root}/unit/init_register/allocate_as_barrier_proc)
  endif ()
  add_mpi_test(get_array 2 ${tests_root}/unit/send-get/get_array)
  add_mpi_test(send_array 2 ${tests_root}/unit/send-get/send_array)
  add_mpi_test(get_with_offset_1d 2 ${tests_root}/unit/send-get/get_with_offset_1d)
  add_mpi_test(whole_get_array 2 ${tests_root}/unit/send-get/whole_get_array)
  add_mpi_test(strided_get 2 ${tests_root}/unit/send-get/strided_get)
  add_mpi_test(co_sum 4 ${tests_root}/unit/collectives/co_sum_test)
  add_mpi_test(co_broadcast 4 ${tests_root}/unit/collectives/co_broadcast_test)
  add_mpi_test(co_min 4 ${tests_root}/unit/collectives/co_min_test)
  add_mpi_test(co_max 4 ${tests_root}/unit/collectives/co_max_test)
  add_mpi_test(syncall 32 ${tests_root}/unit/sync/syncall)
  add_mpi_test(syncimages 32 ${tests_root}/unit/sync/syncimages)
  add_mpi_test(duplicate_syncimages 8 ${tests_root}/unit/sync/duplicate_syncimages)
  add_mpi_test(co_reduce 4 ${tests_root}/unit/collectives/co_reduce_test)
#  add_mpi_test(syncimages_status 32 ${tests_root}/unit/sync/syncimages_status)

  # Integration tests verifying the use of libcaf_mpi in applications
  add_mpi_test(hello_multiverse 2 ${tests_root}/integration/coarrayHelloWorld/hello_multiverse)
  add_mpi_test(coarray_burgers_pde 2 ${tests_root}/integration/pde_solvers/coarrayBurgers/coarray_burgers_pde)
  add_mpi_test(co_heat 2 ${tests_root}/integration/pde_solvers/coarrayHeatSimplified/co_heat)
  if ( ("${CMAKE_SYSTEM_PROCESSOR}" MATCHES "x86_64") AND ("${CMAKE_SYSTEM_NAME}" MATCHES "Linux") )
    if ( NOT (DEFINED ENV{TRAVIS}))
      add_mpi_test(coarray_navier_stokes 2 ${tests_root}/integration/pde_solvers/navier-stokes/coarray_navier_stokes)
      set_property(TEST coarray_navier_stokes PROPERTY PASS_REGULAR_EXPRESSION "Test passed.")
    endif()
  endif()
else()
  add_test(co_sum_extension ${tests_root}/unit/extensions/test-co_sum-extension.sh)
  set_property(TEST co_sum_extension PROPERTY PASS_REGULAR_EXPRESSION "Test passed.")

  add_test(co_broadcast_extension ${tests_root}/unit/extensions/test-co_broadcast-extension.sh)
  set_property(TEST co_broadcast_extension PROPERTY PASS_REGULAR_EXPRESSION "Test passed.")

  add_test(co_min_extension ${tests_root}/unit/extensions/test-co_min-extension.sh)
  set_property(TEST co_min_extension PROPERTY PASS_REGULAR_EXPRESSION "Test passed.")

  add_test(co_max_extension ${tests_root}/unit/extensions/test-co_max-extension.sh)
  set_property(TEST co_max_extension PROPERTY PASS_REGULAR_EXPRESSION "Test passed.")

  add_test(co_reduce_extension ${tests_root}/unit/extensions/test-co_reduce-extension.sh)
  set_property(TEST co_reduce_extension PROPERTY PASS_REGULAR_EXPRESSION "Test passed.")
endif()

=== src/Makefile ===
include make.inc
export

.PHONY : common
.PHONY : single
.PHONY : gasnet
.PHONY : mpi
#.PHONY : armci

mpi: common
	$(MAKE) -C $@

all: common single gasnet mpi # armci

common:
	$(MAKE) -C $@

single: common
	$(MAKE) -C $@

#armci: common
#	$(MAKE) -C $@

gasnet: common
	$(MAKE) -C $@

test: single gasnet mpi #armci
	$(MAKE) -C tests test
test-mpi: mpi
	$(MAKE) -C tests test-mpi
test-gasnet: gasnet
	$(MAKE) -C tests test-gasnet
#test-armci: armci
#	$(MAKE) -C tests test-armci
test-single: single
	$(MAKE) -C tests test-single

run: single armci gasnet mpi
	$(MAKE) -C testsuite run
run-mpi: mpi
	$(MAKE) -C testsuite run-mpi
run-gasnet: gasnet
	$(MAKE) -C testsuite run-gasnet
#run-armci: armci
#	$(MAKE) -C testsuite run-armci
run-single: single
	$(MAKE) -C testsuite run-single

clean:
#	$(MAKE) -k -C common clean
#	$(MAKE) -k -C single clean
#	$(MAKE) -k -C gasnet clean
	$(MAKE) -k -C mpi clean
#	$(MAKE) -k -C tests clean
#	$(MAKE) -k -C armci clean

distclean: clean
	$(MAKE) -k -C common distclean
#	$(MAKE) -k -C single distclean
	$(MAKE) -k -C mpi distclean
#	$(MAKE) -k -C gasnet distclean
#	$(MAKE) -k -C testsuite distclean
#	(MAKE) -k -C armci distclean

=== src/mpi/CMakeLists.txt ===
set(CMAKE_Fortran_MODULE_DIRECTORY ${CMAKE_BINARY_DIR}/mod)

find_package(MPI REQUIRED)

if("${CMAKE_Fortran_COMPILER_ID}" STREQUAL "GNU")
  set(gfortran_compiler true)
elseif("${CMAKE_Fortran_COMPILER_ID}" STREQUAL "Cray")
  set(cray_compiler true)
elseif("${CMAKE_Fortran_COMPILER_ID}" STREQUAL "PGI")
  set(portland_group_compiler true)
endif()

if(gfortran_compiler AND (NOT opencoarrays_aware_compiler))
  # This applied to gfortran 4.9 and some earlier versions (FIX ME: find out which)
  add_definitions(-DCOMPILER_SUPPORTS_CAF_INTRINSICS)
endif()

add_library(caf_mpi mpi_caf.c ../common/caf_auxiliary.c ../extensions/opencoarrays.F90)

target_include_directories(caf_mpi PRIVATE ${MPI_C_INCLUDE_PATH})
if (gfortran_compiler)
  target_compile_options(caf_mpi INTERFACE -fcoarray=lib)
endif()

include_directories(${CMAKE_BINARY_DIR}/mod)

install(TARGETS caf_mpi EXPORT OpenCoarraysTargets
  ARCHIVE DESTINATION lib
)
install(DIRECTORY  ${CMAKE_BINARY_DIR}/mod DESTINATION .)

# Now we write the script that passes CAF source to the compiler with the necessary arguments
# and, if necessary, performs some code transformations prior to invoking the compiler.
set(exe_dir ${CMAKE_BINARY_DIR}/bin_staging)
set(compiler_wrapper ${exe_dir}/caf)
install(
    FILES "${compiler_wrapper}"
    PERMISSIONS WORLD_EXECUTE WORLD_READ WORLD_WRITE OWNER_EXECUTE OWNER_READ OWNER_WRITE GROUP_EXECUTE GROUP_READ GROUP_WRITE
    DESTINATION ${CMAKE_INSTALL_PREFIX}/bin/
)
file(READ ${CMAKE_CURRENT_SOURCE_DIR}/../extensions/caf-head CAF_HEADER)
file(WRITE  "${compiler_wrapper}" "${CAF_HEADER}\n")
file(APPEND "${compiler_wrapper}"  "caf_mod_dir=${CMAKE_INSTALL_PREFIX}/mod\n")
file(APPEND "${compiler_wrapper}"  "caf_lib_dir=${CMAKE_INSTALL_PREFIX}/lib\n")
file(APPEND "${compiler_wrapper}"  "caf_version=${PROJECT_VERSION}\n")
if(gfortran_compiler)
  file(APPEND "${compiler_wrapper}"  "link_args='-fcoarray=lib -lcaf_mpi'\n")
elseif(portland_group_compiler)
  file(APPEND "${compiler_wrapper}"  "link_args=-lcaf_mpi\n")
endif()
if(opencoarrays_aware_compiler)
  file(APPEND "${compiler_wrapper}"  "caf_compiler=true\n")
else()
  file(APPEND "${compiler_wrapper}"  "caf_compiler=false\n")
endif()
if ("${CMAKE_SYSTEM_NAME}" MATCHES "Linux")
  file(APPEND "${compiler_wrapper}"  "linux=true\n")
endif()
file(READ ${CMAKE_CURRENT_SOURCE_DIR}/../extensions/caf-foot FOOTER)
file(APPEND "${compiler_wrapper}" "${FOOTER}")

# Now we write the script that launches executable files produced from CAF codes
set(caf_launcher ${exe_dir}/cafrun)
install(
    FILES "${caf_launcher}"
    PERMISSIONS WORLD_EXECUTE WORLD_READ WORLD_WRITE OWNER_EXECUTE OWNER_READ OWNER_WRITE GROUP_EXECUTE GROUP_READ GROUP_WRITE
    DESTINATION ${CMAKE_INSTALL_PREFIX}/bin
)
file(READ ${CMAKE_CURRENT_SOURCE_DIR}/../extensions/cafrun-head CAFRUN_HEADER)
file(WRITE  "${caf_launcher}" "${CAFRUN_HEADER}\n")
file(APPEND "${caf_launcher}"  "caf_version=${PROJECT_VERSION}\n")

file(READ ${CMAKE_CURRENT_SOURCE_DIR}/../extensions/cafrun-foot FOOTER)
file(APPEND "${caf_launcher}" "${FOOTER}")

# This could be needed to produce shared libraries:
#target_link_libraries(caf_mpi PRIVATE ${MPI_C_LIBRARIES})

#set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES "${exe_dir}/cafrun;${exe_dir}/caf;${exe_dir}/test-caf-tally.sh")

=== src/tests/integration/CMakeLists.txt ===
if (opencoarrays_aware_compiler)
  add_subdirectory(coarrayHelloWorld)
  if (NOT (DEFINED ENV{TRAVIS}))
    add_subdirectory(dist_transpose )
  endif()
  add_subdirectory(pde_solvers)
endif()

=== src/tests/unit/sync/CMakeLists.txt ===
add_executable(syncall syncall.f90)
target_link_libraries(syncall OpenCoarrays)

add_executable(syncimages syncimages.f90)
target_link_libraries(syncimages OpenCoarrays)

add_executable(duplicate_syncimages duplicate_syncimages.f90)
target_link_libraries(duplicate_syncimages OpenCoarrays)

#add_executable(syncimages_status syncimages_status.f90)
#target_link_libraries(syncimages_status OpenCoarrays)

#add_executable(send_array send_array_test.f90)
#target_link_libraries(send_array OpenCoarrays)

#add_executable(get_with_offset_1d get_with_offset_1d.f90)
#target_link_libraries(get_with_offset_1d OpenCoarrays)

#add_executable(whole_get_array whole_get_array.f90)
#target_link_libraries(whole_get_array OpenCoarrays)

#add_executable(strided_get strided_get.f90)
#target_link_libraries(strided_get OpenCoarrays)

=== debian/changelog ===
open-coarrays (1.6.0-1) unstable; urgency=medium
 
  * Initial release. (Closes: #826015).
    Resubmitted with additional license Information, Jun 17

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 17 Jun 2016 12:15:07 +0100

=== debian/control ===
Source: open-coarrays
Section: utils
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper (>= 9), dh-buildinfo,
 mpi-default-dev, mpi-default-bin,
 cmake (>= 3.3.1),
 gfortran (>= 6.1)
Standards-Version: 3.9.8
Homepage: https://www.opencoarrays.org/

Package: libcoarrays-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, gfortran (>= 6.1-1), mpi-default-bin,
 libcoarrays0d (= ${binary:Version})
Description: Co-Array Fortran libraries for gfortran - development files
 OpenCoArrays is an open-source software project that supports the 
 coarray Fortran (CAF) parallel programming features of the Fortran 2008 
 standard and several features proposed for Fortran 2015 in the draft 
 Technical Specification [TS 18508] "Additional Parallel Features in Fortran".
 .
 This package provides the libraries necessary for gfortran to build parallel
 CAF programs built on top of MPI.

Package: libcoarrays0d
Section: libs
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: Co-Array Fortran libraries for gfortran
 OpenCoArrays is an open-source software project that supports the
 coarray Fortran (CAF) parallel programming features of the Fortran 2008
 standard and several features proposed for Fortran 2015 in the draft
 Technical Specification [TS 18508] "Additional Parallel Features in Fortran".
 .
 This package provides the libraries necessary for gfortran to build parallel
 CAF programs built on top of MPI.

Package: open-coarrays-bin
Depends: ${misc:Depends}, libcoarrays0d (= ${binary:Version})
Recommends: libcoarrays-dev
Architecture: any
Description: Executables for running Co-Array Fortran programs
 OpenCoArrays is an open-source software project that supports the
 coarray Fortran (CAF) parallel programming features of the Fortran 2008
 standard and several features proposed for Fortran 2015 in the draft
 Technical Specification [TS 18508] "Additional Parallel Features in Fortran".
 .
 This package provides utility executables for running CAF programs.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

# The magic debhelper  rule
%:
	dh $@ --buildsystem=cmake

DESTDIR:=`pwd`/debian/tmp/
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_auto_configure:
	        CC=mpicc FC=mpifort \
			dh_auto_configure

## open-coarrays 1.7.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 set_property ( CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS ${CMAKE_CONFIGURATION_TYPES} )
 
 #Name project and specify source languages
-project(opencoarrays VERSION 1.6.0 LANGUAGES C Fortran)
+project(opencoarrays VERSION 1.7.4 LANGUAGES C Fortran)
 
 #Print an error message on an attempt to build inside the source directory tree:
 if ("${CMAKE_CURRENT_SOURCE_DIR}" STREQUAL "${CMAKE_CURRENT_BINARY_DIR}")
@@ -151,8 +151,30 @@
 
 enable_testing()
 
+# Determine if we're using Open MPI
+execute_process(COMMAND ${MPIEXEC} --version
+  OUTPUT_VARIABLE mpi_version_out)
+if (mpi_version_out MATCHES "[Oo]pen[ -][Mm][Pp][Ii]")
+  message( STATUS "OpenMPI detected")
+  set ( openmpi true )
+endif ()
+
+include( ProcessorCount )
+ProcessorCount(N)
 function(add_mpi_test name num_mpi_proc path)
-   set(test_parameters ${MPIEXEC_NUMPROC_FLAG} ${num_mpi_proc} )
+   if ( ((N LESS num_mpi_proc) OR (N EQUAL 0)) )
+     message(STATUS "Test ${name} is oversubscribed: ${num_mpi_proc} ranks requested with ${N} system processor available.")
+     if ( openmpi )
+       if ( N LESS 2 )
+	 set( num_mpi_proc 2 )
+	 set (test_parameters --oversubscribed)
+       else()
+	 set ( num_mpi_proc ${N} )
+       endif()
+       message( STATUS "Open-MPI detected, over-riding oversubscribed test, ${name}, with ${num_mpi_proc} ranks." )
+     endif()
+   endif()
+   set(test_parameters ${test_parameters} ${MPIEXEC_NUMPROC_FLAG} ${num_mpi_proc} )
    add_test(NAME ${name} COMMAND ${MPIEXEC} ${test_parameters} "${path}")
    set_property(TEST ${name} PROPERTY PASS_REGULAR_EXPRESSION "Test passed.")
 endfunction(add_mpi_test)
@@ -166,9 +188,7 @@
   add_mpi_test(register_rename_me 2 ${tests_root}/unit/init_register/register_rename_me)
   add_mpi_test(register_rename_me_too 2 ${tests_root}/unit/init_register/register_rename_me_too)
   add_mpi_test(allocate_as_barrier 2 ${tests_root}/unit/init_register/allocate_as_barrier)
-  if (NOT ( APPLE AND ( DEFINED ENV{TRAVIS} ) ) )
-    add_mpi_test(allocate_as_barrier_proc 2 ${tests_root}/unit/init_register/allocate_as_barrier_proc)
-  endif ()
+  add_mpi_test(allocate_as_barrier_proc 32 ${tests_root}/unit/init_register/allocate_as_barrier_proc)
   add_mpi_test(get_array 2 ${tests_root}/unit/send-get/get_array)
   add_mpi_test(send_array 2 ${tests_root}/unit/send-get/send_array)
   add_mpi_test(get_with_offset_1d 2 ${tests_root}/unit/send-get/get_with_offset_1d)
@@ -182,12 +202,13 @@
   add_mpi_test(syncimages 32 ${tests_root}/unit/sync/syncimages)
   add_mpi_test(duplicate_syncimages 8 ${tests_root}/unit/sync/duplicate_syncimages)
   add_mpi_test(co_reduce 4 ${tests_root}/unit/collectives/co_reduce_test)
-#  add_mpi_test(syncimages_status 32 ${tests_root}/unit/sync/syncimages_status)
+  add_mpi_test(syncimages_status 32 ${tests_root}/unit/sync/syncimages_status)
 
   # Integration tests verifying the use of libcaf_mpi in applications
   add_mpi_test(hello_multiverse 2 ${tests_root}/integration/coarrayHelloWorld/hello_multiverse)
   add_mpi_test(coarray_burgers_pde 2 ${tests_root}/integration/pde_solvers/coarrayBurgers/coarray_burgers_pde)
   add_mpi_test(co_heat 2 ${tests_root}/integration/pde_solvers/coarrayHeatSimplified/co_heat)
+  add_mpi_test(asynchronous_hello_world 2 ${tests_root}/integration/events/asynchronous_hello_world)
   if ( ("${CMAKE_SYSTEM_PROCESSOR}" MATCHES "x86_64") AND ("${CMAKE_SYSTEM_NAME}" MATCHES "Linux") )
     if ( NOT (DEFINED ENV{TRAVIS}))
       add_mpi_test(coarray_navier_stokes 2 ${tests_root}/integration/pde_solvers/navier-stokes/coarray_navier_stokes)

=== src/CMakeLists.txt ===
set(directories_to_build mpi tests)
foreach(directory ${directories_to_build})
  add_subdirectory(${directory})
endforeach()

=== src/Makefile ===
# Makefile
#
# -- This Makefile builds the OpenCoarrays libraries using setings in make.inc.
#    (Please edit make.inc before using this Makefile.)
#
#    Instead of using this Makefile, the preferred alternative is to invoke 
#    ./install.sh, which builds the caf compiler wrapper, the cafrun program 
#    launcher, the test suite, and any undetected prerequisite packages, and 
#    which customizes the build for the environment.
#
# Usage (default: GASNET=no):
#    make                      - Builds libcaf_mpi.a, the MPI transport layer.
#    make GASNET=no all        - Builds libcaf_mpi.a and libcaf_gasnet.a.
#    make clean                - Deletes *.o files. Retains *.a files.
#
# OpenCoarrays is distributed under the OSI-approved BSD 3-clause License:
# Copyright (c) 2015-2016, Sourcery, Inc.
# Copyright (c) 2015-2016, Sourcery Institute
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without modification,
# are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice, this
#    list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright notice, this
#    list of conditions and the following disclaimer in the documentation and/or
#    other materials provided with the distribution.
# 3. Neither the names of the copyright holders nor the names of their contributors
#    may be used to endorse or promote products derived from this software without
#    specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
# PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.

include make.inc
export

# Conditionally enable the build of the GASNet library libcaf_gasnet.a,
# an unmaintained but previously functional MPI alterntive.
ifeq ($(GASNET),yes)
  gasnet_=gasnet
endif

.PHONY : common
.PHONY : gasnet
.PHONY : mpi
.PHONY : $(gasent_)

all: common mpi $(gasnet_) 

mpi: common
	$(MAKE) -C $@

common:
	$(MAKE) -C $@

ifeq ($(GASNET),yes)
gasnet: common
	$(MAKE) -C $@
endif

# Delete temporary files files:
clean:
	$(MAKE) -k -C mpi clean
	$(MAKE) -k -C common clean
ifeq ($(GASNET),yes)
	$(MAKE) -k -C gasnet clean
endif

distclean: clean
	$(MAKE) -k -C common distclean
	$(MAKE) -k -C mpi distclean
ifeq ($(GASNET),yes)
	$(MAKE) -k -C gasnet distclean
endif

=== src/common/Makefile ===
include ../make.inc

caf_auxiliary.o: caf_auxiliary.c ../libcaf.h ../libcaf-gfortran-descriptor.h
	$(CC) -I.. $(CFLAGS) -c $< -o $@

clean:
	rm -f caf_auxiliary.o

distclean: clean

=== src/gasnet/Makefile ===
include ../make.inc

MY_GASNET_CFLAGS := $(GASNET_CFLAGS)
MY_GASNET_CC := $(GASNET_CC)
MY_GASNET_LD := $(GASNET_LD)
MY_GASNET_LDFLAGS := $(GASNET_LDFLAGS)

include $(GASNET_MAK)


GASNET_CFLAGS += $(CFLAGS) $(MY_GASNET_CFLAGS)

ifneq ($(MY_GASNET_CC),)
  GASNET_CC = $(MY_GASNET_CC)
endif

ifneq ($(MY_GASNET_LD),)
  GASNET_LD = $(MY_GASNET_LD)
endif

ifneq ($(MY_GASNET_LDFLAGS),)
  GASNET_LDFLAGS = $(MY_GASNET_LDFLAGS)
endif


all: libcaf_gasnet.a

libcaf_gasnet.a: gasnet.o ../common/caf_auxiliary.o
	ar rcv $@ gasnet.o ../common/caf_auxiliary.o
	ranlib $@

.c.o:
	$(GASNET_CC) $(GASNET_CPPFLAGS) $(GASNET_CFLAGS) -I.. -c -o $@ $<

gasnet.o: gasnet.c ../libcaf.h ../libcaf-gfortran-descriptor.h

../common/caf_auxiliary.o:
	$(MAKE) -C ../common

clean:
	rm -f gasnet.o

distclean: clean
	rm -f libcaf_armci.a

=== src/mpi/CMakeLists.txt ===
--- 
+++ 
@@ -53,6 +53,11 @@
 else()
   file(APPEND "${compiler_wrapper}"  "caf_compiler=false\n")
 endif()
+
+if ( DEFINED ENV{FC} )
+  file(APPEND "${compiler_wrapper}"  "CAFC=$ENV{FC}\n")
+endif ()
+
 if ("${CMAKE_SYSTEM_NAME}" MATCHES "Linux")
   file(APPEND "${compiler_wrapper}"  "linux=true\n")
 endif()

=== src/mpi/Makefile ===
include ../make.inc

MPICC ?= mpicc

libcaf_mpi.a: mpi_caf.o ../common/caf_auxiliary.o
	ar rcv $@ mpi_caf.o ../common/caf_auxiliary.o
	ranlib $@

.c.o:
	$(MPICC) $(CFLAGS) $(MPI_CFLAGS) -I.. -c $< -o $@

mpi_caf.o: mpi_caf.c ../libcaf.h ../libcaf-gfortran-descriptor.h

../common/caf_auxiliary.o:
	$(MAKE) -C ../common

clean:
	rm -f mpi_caf.o

distclean: clean
	rm -f libcaf_mpi.a

=== src/single/CMakeLists.txt ===
add_library(caf_single single.c ../common/caf_auxiliary.c)
target_compile_options(caf_single INTERFACE -fcoarray=lib)
install(TARGETS caf_single EXPORT OpenCoarraysTargets
  ARCHIVE DESTINATION lib
)

=== src/single/Makefile ===
include ../make.inc

libcaf_single.a: single.o ../common/caf_auxiliary.o
	ar rcv $@ single.o ../common/caf_auxiliary.o
	ranlib $@

.c.o:
	$(CC) $(CFLAGS) $(SINGLE_CFLAGS) -I.. -c $< -o $@

single.o: single.c ../libcaf.h ../libcaf-gfortran-descriptor.h

../common/caf_auxiliary.o:
	$(MAKE) -C ../common

clean:
	rm -f single.o

distclean: clean
	rm -f libcaf_single.a

=== src/tests/CMakeLists.txt ===
if ("${CMAKE_SYSTEM_NAME}" MATCHES "Linux")
  option(HIGH_RESOLUTION_TIMER "use the walltime.o wallclock timer" FALSE)
  option(LEGACY_ARCHITECTURE "use the SSE-enabled FFT library" FALSE)
endif()

if (HIGH_RESOLUTION_TIMER)
  message(WARNING
    "walltime.o clicks once per clock cycle on an x86 CPU with a 3.6 GHz clock.  "
    "Because modern processors can throttle their clock spees, do not "
    "rely on this timer for an absolute value, but it can be useful for "
    "comparison or relative execution execution times on the same platform."
    )
endif()

add_subdirectory(integration)
add_subdirectory(unit)
#add_subdirectory(performance)

=== src/tests/unit/CMakeLists.txt ===
if (${opencoarrays_aware_compiler})
  add_subdirectory(simple)
  add_subdirectory(send-get)
  add_subdirectory(init_register)
  add_subdirectory(collectives)
  add_subdirectory(sync)
else()
  add_subdirectory(extensions)
endif()

=== src/tests/integration/coarrayHelloWorld/CMakeLists.txt ===
add_executable(hello_multiverse hello_multiverse.F90)
target_link_libraries(hello_multiverse OpenCoarrays)

=== debian/changelog ===
open-coarrays (1.7.4-4) unstable; urgency=medium

  * B-D on openssh-client, as needed to run tests locally?
  
 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 03 Dec 2016 19:21:43 +0000

open-coarrays (1.7.4-3) unstable; urgency=medium

  * Remove multi-arch: same from -dev; .mod files differ
  * Use "--oversubcribe" not "--oversubscribe" for mpiexec. Closes: #846681
  * Disable failure on tests for the moment

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 26 Nov 2016 11:23:14 +0000

open-coarrays (1.7.4-2) unstable; urgency=medium

  * Invert incorrect make check to enable tests
  * Move to unstable

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 15 Nov 2016 11:22:35 +0000

open-coarrays (1.7.4-1) experimental; urgency=medium

  * New upstream release
  * Re-enable tests for alpha, powerpc
  * Multi-Arch enable

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 04 Nov 2016 01:39:33 +0000

open-coarrays (1.7.0-2) unstable; urgency=medium

  * Set debhelper dependency to >= 10.
  * Don't link against static lib in navier_stokes test, breaks -fPIE,
    bindow. Closes: #835148
  * disable alpha, powerpc tests again. Still buggy.

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 14 Sep 2016 16:04:04 +0100

open-coarrays (1.7.0-1) experimental; urgency=medium

  * New upstream release
   - re-enabled tests on alpha, powerpc
  * DH_COMPAT=10

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 05 Sep 2016 08:27:24 +0100

open-coarrays (1.6.2-2) unstable; urgency=medium

  * Disable tests on powerpc, alpha while regression invesigated,
    to allow openmpi2 transition to proceed.

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 09 Aug 2016 12:04:19 +0100

open-coarrays (1.6.2-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 26 Jul 2016 15:28:27 +0100

=== debian/control ===
--- 
+++ 
@@ -2,9 +2,9 @@
 Section: utils
 Priority: optional
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
-Build-Depends: debhelper (>= 9), dh-buildinfo,
+Build-Depends: debhelper (>= 10), dh-buildinfo,
  mpi-default-dev, mpi-default-bin,
- cmake (>= 3.3.1),
+ cmake (>= 3.3.1), openssh-client,
  gfortran (>= 6.1)
 Standards-Version: 3.9.8
 Homepage: https://www.opencoarrays.org/
@@ -26,6 +26,7 @@
 Package: libcoarrays0d
 Section: libs
 Architecture: any
+Multi-Arch: same
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Description: Co-Array Fortran libraries for gfortran
  OpenCoArrays is an open-source software project that supports the
@@ -40,6 +41,7 @@
 Depends: ${misc:Depends}, libcoarrays0d (= ${binary:Version})
 Recommends: libcoarrays-dev
 Architecture: any
+Multi-Arch: same
 Description: Executables for running Co-Array Fortran programs
  OpenCoArrays is an open-source software project that supports the
  coarray Fortran (CAF) parallel programming features of the Fortran 2008

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)

# The magic debhelper  rule
%:
	dh $@ --buildsystem=cmake

DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
# DISABLED_TESTS:= "powerpc alpha"

override_dh_auto_configure:
	        CC=mpicc FC=mpifort dh_auto_configure

override_dh_auto_install:
	dh_auto_install
	mkdir -p debian/tmp/$(LIBDIR)
	cp debian/tmp/usr/lib/libcaf* debian/tmp/$(LIBDIR)
	cp -a debian/tmp/usr/lib/cmake debian/tmp/$(LIBDIR)/cmake
	dh_link -p libcoarrays-dev $(LIBDIR)/libcaf_single.so.0d $(LIBDIR)/libcaf_single.so
	dh_link -p libcoarrays-dev $(LIBDIR)/libcaf_mpi.so.0d $(LIBDIR)/libcaf_mpi.so

override_dh_auto_test:
ifneq (,$(findstring  "$(DEB_HOST_ARCH)",$(DISABLED_TESTS)))
	@echo "Tests disabled on this arch: known failures being investigated"
else
	-dh_auto_test
endif
